> For the complete documentation index, see [llms.txt](https://docs.pentaho.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.pentaho.com/install/10.2-install/multidimensional-data-modeling-in-pentaho/about-multidimensional-expression-language/mondrian-schema-element-reference/level/attributes.md).

# Attributes

| Attribute       | Data Type | Definition                                                                                                                                                                                                                                                                                                                                                                                                                                                     |
| --------------- | --------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| approxRowCount  | String    | The estimated number of members in this level. Setting this property improves the performance of**MDSCHEMA\_LEVELS**,**MDSCHEMA\_HIERARCHIES** and **MDSCHEMA\_DIMENSIONS XMLA** requests                                                                                                                                                                                                                                                                      |
| name            | String    |                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| table           | String    | The name of the table that the column comes from. If this hierarchy is based upon just one table, defaults to the name of that table; otherwise, it is required. Can be localized from Properties file using **#{propertyname}**.                                                                                                                                                                                                                              |
| column          | String    | The name of the column which holds the unique identifier of this level.                                                                                                                                                                                                                                                                                                                                                                                        |
| nameColumn      | String    | The name of the column which holds the user identifier of this level.                                                                                                                                                                                                                                                                                                                                                                                          |
| ordinalColumn   | String    | The name of the column which holds member ordinals. If this column is not specified, the key column is used for ordering.                                                                                                                                                                                                                                                                                                                                      |
| parentColumn    | String    | The name of the column which references the parent member in a parent-child hierarchy.                                                                                                                                                                                                                                                                                                                                                                         |
| nullParentValue | String    | Value which identifies null parents in a parent-child hierarchy. Typical values are *NULL* and *0*.                                                                                                                                                                                                                                                                                                                                                            |
| type            | String    | Indicates the type of this level's key column: String, Numeric, Integer, Boolean, Date, Time or Timestamp. When generating SQL statements, Mondrian encloses values for String columns in quotation marks, but leaves values for Integer and Numeric columns un-quoted. Date, Time, and Timestamp values are quoted according to the SQL dialect. For a SQL-compliant dialect, the values appear prefixed by their typename, for example, *DATE '2006-06-01'*. |
| uniqueMembers   | Boolean   | Whether members are unique across all parents. For example, zipcodes are unique across all states. The first level's members are always unique.                                                                                                                                                                                                                                                                                                                |
| levelType       | String    | Whether this is a regular or a time-related level. The value makes a difference to time-related functions such as YTD (year-to-date).                                                                                                                                                                                                                                                                                                                          |
| hideMemberIf    | String    | Condition which determines whether a member of this level is hidden. If a hierarchy has one or more levels with hidden members, then it is possible that not all leaf members are the same distance from the root, and it is termed a ragged hierarchy.                                                                                                                                                                                                        |
| formatter       | String    | Name of a formatter class for the member labels being displayed. The class must implement the **mondrian.olap.MemberFormatter** interface. Allowable values are: Never (a member always appears; the default); *IfBlankName* (a member doesn't appear if its name is null or empty); and *IfParentsName* (a member appears unless its name matches the parent's.                                                                                               |
| caption         | String    | A string being displayed instead of the level's name. Can be localized from Properties file using **#{propertyname}**.                                                                                                                                                                                                                                                                                                                                         |
| captionColumn   | String    | The name of the column which holds the caption for members.                                                                                                                                                                                                                                                                                                                                                                                                    |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.pentaho.com/install/10.2-install/multidimensional-data-modeling-in-pentaho/about-multidimensional-expression-language/mondrian-schema-element-reference/level/attributes.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
